<template>
    <div>
        <div class="d-flex justify-content-between">
            <div>
                <h1 class="h3 mb-4 text-gray-800">USER</h1>
            </div>
            <div>
                <router-link
                    v-show="isAdmin"
                    :to="{ name: 'UserCreate' }"
                    class="btn btn-success"
                    role="button"
                    >Create User</router-link
                >
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <search-box
                    @input="getObjects"
                    delay="500"
                    ref="searchBox"
                ></search-box>
            </div>
        </div>
        <b-card>
            <div class="table-responsive">
                <table class="table">
                    <thead>
                        <tr>
                            <th>ID</th>
                            <th>First Name</th>
                            <th>Last Name</th>
                            <th>Nick Name</th>
                            <th>Email</th>
                            <th>Department</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="object in dataObjects" :key="object.id">
                            <td scope="row">
                                <router-link
                                    v-if="isAdmin"
                                    :to="{
                                        name: 'UserEdit',
                                        params: { id: object.id }
                                    }"
                                    >{{ object.id }}</router-link
                                >
                                <span v-else>{{ object.id }}</span>
                            </td>
                            <td>{{ object.first_name }}</td>
                            <td>{{ object.last_name }}</td>
                            <td>{{ object.nick_name }}</td>
                            <td>{{ object.email }}</td>
                            <td>
                                {{
                                    object.department
                                        ? object.department.name
                                        : "NA"
                                }}
                            </td>
                            <td v-show="isAdmin">
                                <a
                                    v-show="!object.approved_at"
                                    @click="onApprove(object)"
                                    class="btn btn-success rounded-circle btn-sm"
                                >
                                    <i class="fas fa-check"></i>
                                </a>
                            </td>
                        </tr>

                        <tr v-if="dataObjects.length == 0">
                            <td class="text-center" colspan="6">
                                There is no user record
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </b-card>
    </div>
</template>

<script>
import SearchBox from "../../components/SearchBoxComponent";
import BCard from "../../components/CardComponent";
import Swal from "sweetalert2";
export default {
    components: {
        SearchBox,
        BCard
    },
    data() {
        return {
            dataObjects: [],
            isAdmin: this.$isAdmin == "1"
        };
    },
    created() {
        this.prepare();
    },
    mounted() {
        this.$refs.searchBox.$refs.searchBox.focus();
    },
    methods: {
        prepare() {
            this.getObjects();
        },
        getObjects(search = "") {
            axios
                .get("/api/user/all", {
                    params: {
                        limit: 10,
                        search: search
                    }
                })
                .then(res => {
                    this.dataObjects = res.data;
                })
                .catch(err => {
                    console.log(err.message);
                });
        },
        onApprove(object) {
            Swal.fire({
                title: "Do you want to approve?",
                icon: "info",
                confirmButtonText: "Yes, Approve",
                cancelButtonText: "No, cancel",
                showCancelButton: true
            }).then(result => {
                if (result.isConfirmed) {
                    axios
                        .get("/api/user/" + object.id + "/approve")
                        .then(res => {
                            object.approved_at = new Date();
                        })
                        .catch(err => {
                            console.log(err.message);
                        });
                }
            });
        },
        onDeleted() {
            this.$refs.searchBox.$refs.searchBox.focus();
            this.getObjects();
        }
    }
};
</script>
